AchievementBackToBasics = class(Turbine.UI.Control)
function AchievementBackToBasics:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        ["Spear and Spear"] = true,
        ["Spear and Shield"] = true,
        ["Spear and Fist"] = true,
        ["Shield and Shield"] = true,
        ["Shield and Spear"] = true,
        ["Shield and Fist"] = true,
        ["Fist and Fist"] = true,
        ["Fist and Shield"] = true,
        ["Fist and Spear"] = true,
    }

    self.playerName = Turbine.Gameplay.LocalPlayer.GetInstance():GetName()

    self.command = Turbine.ShellCommand()
    function self.command:Execute()
        HardcoreHandler:GetAchievementHint("Back To Basics")
    end

    Turbine.Shell.AddCommand("hardcorebacktobasics", self.command)
    ChatOutput("Use the command /hardcorebacktobasics to see a list of affected skills")


    self.handler = handler

    self:SetCallbacks()
end

function AchievementBackToBasics:SetCallbacks()
    self.skillCallbacks = {}
    for key, value in pairs(SkillEventHandler:GetSkills()) do
        ChatOutput(key)
        if self.skillList[key] then


            table.insert(self.skillCallbacks, AddCallback(SkillEventHandler, key, function(skill) 
                self.handler:Fail("Back To Basics", "Usage of a mastery", 0x410E0DCA)
            end))
        end
    end

    self.benefitCallback = AddCallback(ChatEventHandler, "PlayerBenefit", function(args)
        if args.Source == self.playerName and self.skillList[args.SkillName] then
            self.handler:Fail("Back To Basics", "Usage of a mastery", 0x410E0DCA)
        end
    end)
end

function AchievementBackToBasics:Unload()
    for key, value in pairs(self.skillCallbacks) do
        RemoveCallback(SkillEventHandler, key, value) 
    end

    RemoveCallback(ChatEventHandler, "PlayerBenefit", self.benefitCallback)
end

function AchievementBackToBasics:Refresh()
    self:Unload()
    self:SetCallbacks()
end

function AchievementBackToBasics:GetHint()
    ChatOutput("<rgb=#FF0000>Gambit masteries are not allowed to be used")
end